/*
 * Synchronisation support.
 *
 * Copyright (C) 2018, 2019, 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/sys/types.h>

#include <fsserver/queue.h>



/* A generic class for an object offering synchronisation support. */

class SyncSupport
{
protected:
  /* Client endpoint when accessing queues. */

  l4_cap_idx_t _client_ep = L4_INVALID_CAP;

  virtual long ensure_client();

public:
  /* Synchronisation methods. */

  virtual long begin();

  virtual long begin_first();

  virtual long end();

  virtual long yield();

  /* Queue access. */

  virtual Queue *queue() = 0;
};
